Loganal - an MQSeries error log analysis utility

Chris Bell
Systems Consultant, British Airways (UK)  c Xephon 2002



loganal -h
loganal start    on: 05/01/02
                 at: 14:09:53
MQ Error Log Analayis Utility
Usage: loganal [-options]
Options:
-h        Explain parameters
-c  file  Config File to get parameters from    (Default - none)
-d  dir   MQ log file directory           (Default - Current Directory)
-L1 file  MQ Error Log to analayse        (Default - AMQERR01.LOG)
-L2 file  Additional MQ Error Log to analyse     (Default - none)
-L3 file  Additional MQ Error Log to analyse     (Default - none)
          Note:
          If more than L1 is used - L1 must be
          the most recent log with L2 older and
          and L3 the oldest
-D  date  The date of log entries to check       (Default - today)
-T1 time  The start time of entries to analyse   (Default 00:00:01)
-T2 time  The end time of entries to analyse     (Default 23:59:59)
-s  code  Search for this AMQnnnn error          (Default - none)
-X1 code  Exclude this AMQnnnn error             (Default - none)
-X2 code  Exclude this AMQnnnn error             (Default - none)
-X3 code  Exclude this AMQnnnn error             (Default - none)
-S  s|d   Summary or Detail. s = Summary         (Default - d)
                             d = detail


-d=\temp
-L1=Amqerr01.log
-D=04/01/02
-T1=16:00:00
-T2=16:30:00
-s=AMQZ002


     loganal -L1 AMQERR03.LOG -L2 AMQERR02.LOG -L3 AMQERR01.LOG SSSS.


>loganal -D 04/01/02 -T1 12:16:00 -T2 12:19:00
loganal start    on: 05/01/02
                 at: 14:48:29
SummaryDetail   d
Directory       .\
SearchDate      04/01/02
Start Time      12:16:00
End Time        12:19:00
Log 1           AMQERR01.LOG
************ Results ************
04/01/02  12:16:01 AMQ9002: Channel program started.
04/01/02  12:16:02 AMQ9002: Channel program started.
04/01/02  12:17:04 AMQ9208: Error on receive from host A164367N (161.2.158.172).
04/01/02  12:17:28 AMQ9208: Error on receive from host A164367N (161.2.158.172).
********** End Results **********
loganal End      on: 05/01/02
                 at: 14:48:29


>loganal -D 04/01/02 -S s
loganal start    on: 05/01/02
                 at: 17:50:58
SummaryDetail   s
Directory       .\
SearchDate      04/01/02
Start Time      00:00:01
End Time        23:59:59
Log 1           AMQERR01.LOG
************ Results ************
Error Code      Occurrences
AMQ9001             14
AMQ9002             14
AMQ9208             40
AMQ9545             14
********** End Results **********
loganal End      on: 05/01/02
                 at: 17:50:58
>



/* Program name: LOGANAL                                            */
/* Description: Utility to analyse MQSeries Error Logs              */
/********************************************************************/
/*   LOGANAL has many optional parameters ...                       */
/*        - these are fully described in the "disphelp" function    */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
/* If you are on Unix - set MYENV to "unix", if on NT set it to "NT"*/
#define MYENV "NT"
void disphelp(void);
void sorterrs(char *strings[], int num);


int main(int argc, char **argv)
{
 char     CurrTime[10];     /* Hold Current Time         */
 char CurrDate[10];         /* Hold Current Date                    */
 struct tm *newtime;         /* Structure for time fields            */
 time_t long_time;           /* Time variable                        */
 int ParmCount;             /* Parameters passed                    */
 char GetConfig = 'n';      /* Parms from config file ?             */
 char SummaryDetail[2] = "d";  /* Summary or Detail report ?        */
 char ConfigFile[24] = "loganal.cfg"; /* Parameter config file      */
 char LogDir[80];    /      * MQ Error Log Directory                */
 char SlashChar[2];         /* Directory Separator                  */
 char SearchDate[10];       /* Error Date to search for             */
 char SearchFor = 'n';      /* Search for specific error ?          */
 char SearchErr[10] = "AMQ0000";  /* AMQnnnn code to search for     */
 char LogErr[10];           /* AMQnnnn code found in log            */
 char OutputFileName[24] = "  ";  /* File for report output         */
 char OutputFile = 'n';     /* Report to output file ?              */
 char log1[24] = "AMQERR01.LOG";  /* Primary Error Log              */
 char log2[24] = "none";   /* Additional Error Log                  */
 char log3[24] = "none";   /* Additional Error Log                  */
 char LogFile[100];        /* Log File path/name                    */
 char StartTime[10] = "00:00:01"; /* Start Time to search for       */
 char EndTime[10]   = "23:59:59"; /* End Time to search for         */
 char FBuffer[100];        /* Buffer for reading files              */
 char HoldBuf[100];        /* Buffer for previous line              */
 int OutCtr = 0;           /* Number of errors found                */
 int HoldCtr = 0;          /* Hold Counter                          */
 char HoldDate[10];        /* Hold Date                             */
 char HoldAMPM[4];         /* AM, PM or '  '                        */
 char HoldTime[10];        /* Hold Time                             */
 char WorkTime[10];        /* Temp work field                       */
 char SummErr[20][8] = {"xxxxxxx", "xxxxxxx", "xxxxxxx", "xxxxxxx",
        "xxxxxxx", "xxxxxxx", "xxxxxxx", "xxxxxxx", "xxxxxxx",
        "xxxxxxx", "xxxxxxx", "xxxxxxx", "xxxxxxx", "xxxxxxx",
        "xxxxxxx", "xxxxxxx", "xxxxxxx", "xxxxxxx", "xxxxxxx"};
     /* Error Codes found                                           */
 int NextErr = 0;          /* Temp work field                       */
 static int ErrCnt[20];    /* Error Code occurrences                */
 char *ptstr[20];          /* Temp array for sorting                */
 char LineOut[20][80];     /* Temp array for sorting                */
 int Exclude = 0;          /* Errors to exclude ?                   */
 char Excluded[3][8] = {"none", "none", "none"}; /* AMQnnnn codes to


 int Workhhi;              /* Working variable for time             */
 char Workhhs[2];          /* Working variable for time             */
 int LogIntTime;           /* Error's time as integer               */
 int StartIntTime;         /* Start time as integer                 */
 int EndIntTime;           /* End time as integer                   */
 char *token;              /* Work variable for strtok              */
 char *fparm1;             /* Work variable - config file           */
 char *fparm2;             /* Work variable - config file           */
 char fparm3[80] = "\0";   /* Work variable - config file           */
 int i = 1;                /* Counter variable                      */
 int j,k;                  /* Counter variables                     */
 char blank[] = " ";       /* Constant                              */
 int pos;                  /* Work variable                         */
 int OK;                   /* Work variable                         */
 char TooLate = 'n';       /* Work variable                         */
 char HoldLog[3][24];      /* Work variable                         */
 FILE *fpc, *fpl, *fpout;  /* File pointers                         */
/* Get System Date and current Time */
 time( &long_time );
newtime = localtime( &long_time );
strftime(CurrDate, 10, "%d/%m/%y", newtime);
 CurrDate[8] = '\0';
strftime(CurrTime, 10, "%H:%M:%S", newtime);
 CurrTime[8] = '\0';
 /* Display Start Messages                                          */
 printf(" \n");
 printf("%s start \t on: %s \n", argv[0], CurrDate);
 strcpy(SearchDate, CurrDate);
 SearchDate[8] = '\0';
 printf ("    \t at: %s \n", CurrTime);
 printf(" \n");
 /* Set appropriate directory separator for Unix or NT              */
 if (memcmp(MYENV, "NT", 2) == 0)
 {
  strcpy(LogDir,  ".\\");
  SlashChar[0] = '\\';
  SlashChar[1] = '\0';
 }
 else if (memcmp(MYENV, "unix", 4) == 0)
 {
  strcpy(LogDir, "./");
 strcpy(SlashChar, "/");
 }
 else
 {
  printf("The setting of MYENV is invalid ... \n");
  printf("Exiting .... \n");
 }

 /* Read in all parameters passed and process ...                   */
 ParmCount = 1;
 while (argc > ParmCount)
 {
  if (ParmCount < argc && memcmp(argv[ParmCount], "-c", 2) == 0)
  {
   /* Parms in a config file - make sure this is the only           */
   /* parameter passed .....                                        */
   GetConfig = 'y';
   if ((memcmp(argv[ParmCount+1], "-", 1) ==0) ||
    (argc > 3))
   {
    printf("-c Option if used must be the only one ... \n");
    printf("Exiting ... \n");
    return 1;
   }
   strcpy(ConfigFile, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-d", 2) == 0)
  {
   /* Log File directory selected                                   */
   strcpy(LogDir, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-D", 2) == 0)
  {
   /* Search Date for errors selected                               */
   strcpy(SearchDate, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-f", 3) == 0)
  {
   /* Output File for results                                       */
   strcpy(OutputFileName, argv[ParmCount+1]);
   OutputFile = 'y';
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-h", 2) == 0)
  {
   /* Display Help text                                             */
   if (argc > 2)
   {
    printf("Invalid parameters passed ... \n");
    printf("-h parameter must be on its own \n");
    return 9;
   }
   disphelp();
   return 0;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-L1", 3) == 0)
  {
   /* Primary Log File to process                                   */
   strcpy(log1, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-L2", 3) == 0)
  {
   /* Second Log File to process                                    */
   strcpy(log2, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-L3", 3) == 0)
  {
   /* Third Log File if needed */
   strcpy(log3, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-X1", 3) == 0)
  {
   /* Exclude this specific AMQnnnn from the search                 */
   if (SearchFor == 'y')
   {
    printf("Exclude (-Xn) and Search For (-s) cannot be used together


    printf("Exiting ...... \n");
    return 1;
   }
   strcpy(Excluded[0], argv[ParmCount+1]);
   Exclude = 1;
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-X2", 3) == 0)
  {
   /* Exlude second error code from search                          */
   if (SearchFor == 'y')
   {
    printf("Exclude (-Xn) and Search For (-s) cannot be used together


    printf("Exiting ...... \n");
    return 1;
   }
   strcpy(Excluded[1], argv[ParmCount+1]);
   Exclude = 1;
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-X3", 3) == 0)
  {
   /* Exclude third error code from search                          */
   if (SearchFor == 'y')
   {
    printf("Exclude (-Xn) and Search For (-s) cannot be used together ... \n");
    printf("Exiting ...... \n");
    return 1;
   }
   strcpy(Excluded[2], argv[ParmCount+1]);
   Exclude = 1;
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-s", 2) == 0)
  {
   /* Search for a specific AMQnnnn code in the logs                */
   if (Exclude == 1)
   {
    printf("Exclude (-Xn) and Search For (-s) cannot be used together


    printf("Exiting ...... \n");
    return 1;
   }
   SearchFor = 'y';
   strcpy(SearchErr, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-S", 2) == 0)
  {
   /* Specify report level of detail                                */
   strcpy(SummaryDetail, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-T1", 3) == 0)
  {
   /* Start time for error search                                   */
   strcpy(StartTime, argv[ParmCount+1]);
   ParmCount += 2;
  }
  if (ParmCount < argc && memcmp(argv[ParmCount], "-T2", 3) == 0)
  {
   /* End time for error search                                     */
   strcpy(EndTime, argv[ParmCount+1]);
   ParmCount += 2;
  }
 } /* End While Loop */
 if (GetConfig == 'y')
 {
 /* Parameters are to be read from a file                           */
 fpc = fopen(ConfigFile, "r");
 if (fpc == NULL)
 {
   printf("Error reading Config File %s ...\n", ConfigFile);
  printf("Aborting run ... \n");
  return 1;
 }
 printf("Reading parms from config file .... \n");
 while (fgets(FBuffer, sizeof(FBuffer), fpc) != NULL)
 {
  /* Extract line from config file by getting tokens                */
  token = strtok(FBuffer, "=" );
  while(token != NULL)
  {
   /* While there are tokens in "FBuffer" */
   if (i == 1)
     fparm1 = token;
   else
     fparm2 = token;
   /* Get next token: */
   token = strtok( NULL, "=" );
   i++;
  }
   /* Remove trailing blanks from fparm2                            */
  pos = strcspn(fparm2, blank);
  strncpy(fparm3, fparm2, (pos-1));
  fparm3[pos-1] = '\0';
   /* Set all variables from  config file entries                   */
  if (strcmp(fparm1,"-d")==0)
  {
   strcpy(LogDir, fparm3);
  }
  if (strcmp(fparm1,"-D")==0)
  {
   strcpy(SearchDate, fparm3);
  }
  if (strcmp(fparm1,"-f")==0)
  {
   strcpy(OutputFileName, fparm3);
   OutputFile = 'y';
  }
  if (strcmp(fparm1,"-L1")==0)
  {
   strcpy(log1, fparm3);
  }
  if (strcmp(fparm1,"-L2")==0)
  {
   strcpy(log2, fparm3);
  }
  if (strcmp(fparm1,"-L3")==0)
  {
   strcpy(log3, fparm3);
  }
  if (strcmp(fparm1,"-X1")==0)
  {
   strcpy(Excluded[0], fparm3);
   Exclude = 1;
  }
  if (strcmp(fparm1,"-X2")==0)
  {
   strcpy(Excluded[1], fparm3);
   Exclude = 1;
  }
  if (strcmp(fparm1,"-X3")==0)
  {
   strcpy(Excluded[2], fparm3);
   Exclude = 1;
  }
  if (strcmp(fparm1,"-s")==0)
  {
   SearchFor = 'y';
   strcpy(SearchErr, fparm3);
  }
  if (strcmp(fparm1,"-S")==0)
  {
   strcpy(SummaryDetail, fparm3);
  }
  if (strcmp(fparm1,"-T1")==0)
  {
   strcpy(StartTime, fparm3);
  }
  if (strcmp(fparm1,"-T2")==0)
  {
   strcpy(EndTime, fparm3);
  }
 } /* End While(fgets ....                                          */
 if (fclose(fpc) != 0)
  printf("Error Closing Config File %s \n", ConfigFile);
 } /* End if (GetCongif = = 'y') ...                                */
 if (OutputFile == 'y')
 {
  /* Output to be routed to a file ...                              */
  fpout = fopen(OutputFileName, "w");
  if (fpout == NULL)
  {
   printf("Error opening Output File %s ...\n", OutputFileName);
   printf("Aborting run ... \n");
   return 1;
  }
 }
 /* Echo parameters selected including those that have              */
 /* taken their default values - either to screen or output file    */
 printf("\n");
 if (OutputFile == 'y')
 {
   fprintf(fpout, "SummaryDetail \t%s \n", SummaryDetail);
  fprintf(fpout, "Directory \t%s \n", LogDir);
  fprintf(fpout, "SearchDate \t%s \n", SearchDate);
  if (OutputFile == 'y')
      printf("Output File \t%s \n", OutputFileName);
  fprintf(fpout, "Start Time \t%s \n", StartTime);
  fprintf(fpout, "End Time \t%s \n", EndTime);
  fprintf(fpout, "Log 1 \t\t%s \n", log1);
  if (memcmp(log2, "none", 4) !=0)
      fprintf(fpout, "Log 2 \t\t%s \n", log2);
  if (memcmp(log3, "none", 4) !=0)
      fprintf(fpout, "Log 3 \t\t%s \n", log3);
  if (memcmp(Excluded[0], "none", 4) != 0)
      fprintf(fpout, "Excluded \t%s \n", Excluded[0]);
  if (memcmp(Excluded[1], "none", 4) != 0)
      fprintf(fpout, "Excluded \t%s \n", Excluded[1]);
  if (memcmp(Excluded[2], "none", 4) != 0)
      fprintf(fpout, "Excluded \t%s \n", Excluded[2]);
  fprintf(fpout, "\n************ Results ************\n\n");
 }
 else
 {
   printf("SummaryDetail \t%s \n", SummaryDetail);
  printf("Directory \t%s \n", LogDir);
  printf("SearchDate \t%s \n", SearchDate);
  if (SearchFor == 'y')
      printf("Search For \t%s \n", SearchErr);
  printf("Start Time \t%s \n", StartTime);
  printf("End Time \t%s \n", EndTime);
  printf("Log 1 \t\t%s \n", log1);
  if (memcmp(log2, "none", 4) !=0)
      printf("Log 2 \t\t%s \n", log2);
  if (memcmp(log3, "none", 4) !=0)
      printf("Log 3 \t\t%s \n", log3);
  if (memcmp(Excluded[0], "none", 4) != 0)
      printf("Excluded \t%s \n", Excluded[0]);
  if (memcmp(Excluded[1], "none", 4) != 0)
      printf("Excluded \t%s \n", Excluded[1]);
  if (memcmp(Excluded[2], "none", 4) != 0)
      printf("Excluded \t%s \n", Excluded[2]);
  printf("\n************ Results ************\n\n");
 }
 /* Read each Log File specified in turn ... */
 strcpy(HoldLog[0], log1);
 strcpy(HoldLog[1], log2);
 strcpy(HoldLog[2], log3);
 HoldCtr = 0;
 while ((memcmp(HoldLog[HoldCtr], "none", 4) != 0) &
  (TooLate == 'n'))
 {
  strcpy(LogFile, LogDir);
  strcat(LogFile, SlashChar);
  strcat(LogFile, HoldLog[HoldCtr]);
  fpl = fopen(LogFile, "r");
  if (fpl == NULL)
  {
   printf("Error reading Log File %s ...\n", LogFile);
   printf("Aborting run ... \n");
   return 1;
  }
 /* Keep reading Log File until time is past search window          */
    while ((fgets(FBuffer, sizeof(FBuffer), fpl) != NULL) &
   (TooLate == 'n'))
 {
  OK = 1;
  if (memcmp(FBuffer, "AMQ", 3) == 0)
  {
   /* Previous line will contain the error's date and time          */
   strncpy(HoldDate, HoldBuf, 8);
   strncpy(HoldTime, HoldBuf+10, 8);
   strncpy(HoldAMPM, HoldBuf+19, 2);
   HoldDate[8] = '\0';
   HoldTime[8] = '\0';
   HoldAMPM[2] = '\0';
   strncpy(LogErr, FBuffer, 7);
   LogErr[7] = '\0';
  }
  else
  {
   OK = 0;
   strcpy(HoldBuf, FBuffer);
  }
  /* Has this error been excluded ?                                 */
  for (i=0; i < 3; i++)
  {
   if (memcmp(LogErr, Excluded[i], 7) == 0)
    OK = 0;
  }
  if (OK == 1)
  {
   /* Check Date and Time...                                        */
   if (memcmp(HoldAMPM, "PM", 2) == 0)
   {
    strncpy(WorkTime, HoldTime+3, 2);
    strncpy(WorkTime+2, HoldTime+6, 2);
    WorkTime[4] = '\0';
    strncpy(Workhhs, HoldTime, 2);
    Workhhs[2] = '\0';
    Workhhi = atoi(Workhhs) + 12;
    LogIntTime = (atoi(WorkTime) + (Workhhi * 10000));
   }
   else
   {
    strncpy(WorkTime, HoldTime, 2);
    strncpy(WorkTime+2, HoldTime+3, 2);
    strncpy(WorkTime+4, HoldTime+6, 2);
    WorkTime[6] = '\0';
    LogIntTime = atoi(WorkTime);
   }
   strncpy(WorkTime, StartTime, 2);
   strncpy(WorkTime+2, StartTime+3, 2);
   strncpy(WorkTime+4, StartTime+6, 2);
   WorkTime[6] = '\0';
   StartIntTime = atoi(WorkTime);
   strncpy(WorkTime, EndTime, 2);
   strncpy(WorkTime+2, EndTime+3, 2);
   strncpy(WorkTime+4, EndTime+6, 2);
   WorkTime[6] = '\0';
   EndIntTime = atoi(WorkTime);
   if ((memcmp(SearchDate, HoldDate, 8) == 0) &
    (LogIntTime >= StartIntTime)  &
    (LogIntTime <= EndIntTime))
    OK = 1;
   else
    OK = 0;
    /*  Passed Date and Time test ...                               */
  }
  /* If we are on the correct date - are we past the time window ?  */
  if ((memcmp(SearchDate, HoldDate, 8) == 0) &
   (LogIntTime > EndIntTime))
   TooLate = 'y';
  if ((OK ==1) &
   (SearchFor == 'y'))
  {
   /* Search for specific error                                     */
   if (memcmp(LogErr, SearchErr, 7) == 0)
    OK = 1;
   else
    OK = 0;
  }
  if ((OK == 1) &
   (memcmp(SummaryDetail, "s", 1) == 0))
  {
   /* Summary report chosen ...                                     */
   /* Have we already seen this error ?                             */
   i = 0;
   j = 0;
   while ((memcmp(SummErr[i], "xxxxxxx", 7) != 0) &
       (i < 20))
   {
    if (memcmp(LogErr, SummErr[i], 7) == 0)
    {
     ErrCnt[i]++;
     j = 1;
    }
    i++;
   }
   /* New error seen ... ?                                          */
   if (j == 0)
   {
    strcpy(SummErr[NextErr], LogErr);
    ErrCnt[NextErr]++;
    OutCtr++;
    NextErr++;
   }
  }
   /* Output for "Detail" report to screen                          */
  if ((OK == 1) &
   (memcmp(SummaryDetail, "d", 1) == 0) &
   (OutputFile == 'n'))
  {
   HoldBuf[18] = ' ';
   HoldBuf[19] = '\0';
   strcat(HoldBuf, FBuffer);
   printf("%s", HoldBuf);
   OutCtr++;
  }
  /* Output for "Detail" report to file                             */
  if ((OK == 1) &
   (memcmp(SummaryDetail, "d", 1) == 0) &
   (OutputFile == 'y'))
  {
   HoldBuf[18] = ' ';
   HoldBuf[19] = '\0';
   strcat(HoldBuf, FBuffer);
   fprintf(fpout, "%s", HoldBuf);
   OutCtr++;
  }
 } /* End while (fgets(FBuffer ...                                  */
 if (fclose(fpl) != 0)
   printf("Error Closing Log File %s \n", ConfigFile);
 HoldCtr++;
 } /* End while (memcmp(HoldLog[i], "none", 4 ....                  */
 /* Summary Output ....                                             */
 if ((memcmp(SummaryDetail, "s", 1) == 0) &
  (OutCtr > 0))
 {
   for (i = 0; memcmp(SummErr[i], "xxxxxxx", 7) !=0; i++)
  sprintf(LineOut[i], "%s %d", SummErr[i], ErrCnt[i]);
  for (k = 0; k < 18; k++)
  {
   ptstr[k] = LineOut[k];
  }
  /* Sort the errors found                                          */
  sorterrs(ptstr, k);
  /* Output summary of errors to screen or a file                   */
  if (OutputFile == 'y')
  {
   fprintf(fpout, "Error Code \tOccurrences \n\n");
   for (k = 0; k < 18; k++)
   {
    if (memcmp(ptstr[k], "AMQ", 3) == 0)
    fprintf(fpout, "%s \n", ptstr[k]);
   }
  }
  else
  {
   printf("Error Code \tOccurrences \n\n");
   for (k = 0; k < 18; k++)
   {
    if (memcmp(ptstr[k], "AMQ", 3) == 0)
    printf("%s \n", ptstr[k]);
   }
  }
 }
 /* We didn't find any errors that matched the search parameters    */
 if (OutCtr == 0 )
  printf("No matching log entries were found .... \n");
 /* Output trailer block                                            */
 if (OutputFile == 'y')
 {
  fprintf(fpout, "\n********** End Results **********\n\n");
  if (fclose(fpout) != 0)
   printf("Error Output File %s \n", OutputFileName);
 }
 else printf("\n********** End Results **********\n\n");
 printf("%s End \t on: %s \n", argv[0], CurrDate);
 strcpy(SearchDate, CurrDate);
 SearchDate[8] = '\0';
time( &long_time );
newtime = localtime( &long_time );
strftime(CurrTime, 10, "%H:%M:%S", newtime);
 CurrTime[8] = '\0';
 printf("    \t at: %s \n", CurrTime);
 printf(" \n");
 return 0;
} /* End Main                                                       */
/* Display utility help                                              */
void disphelp(void)
{
  printf("MQ Error Log Analayis Utility\n\n");
printf("Usage: loganal [-options]\n");
printf("Options:\n");
printf("-h    Explain parameters\n");
printf("-d  dir   MQ log file directory\t\t\t (Default - Current


printf("-c  file  Config File to get parameters from\t (Default -


printf("-L1 file MQ Error Log to analayse\t\t (default -


printf("-L2 file  Additional MQ Error Log to analyse\t (Default -


printf("-L3 file  Additional MQ Error Log to analyse\t (Default -


printf("  Note:\n");
printf("  If more than L1 is used - L1 must be\n");
printf("  the most recent log with L2 older and\n");
printf("  and L3 the oldest\n");
printf("-D  date  The date of log entries to check\t (Default - today)\n");
printf("-T1 time  The start time of entries to analyse\t (Default 00:00:01)\n");
printf("-T2 time  The end time of entries to analyse\t (Default 23:59:59)\n");
printf("-s  code  Search for this AMQnnnn error\t\t (Default - none)\n");
printf("-X1 code  Exclude this AMQnnnn error\t\t (Default - none)\n");
printf("-X2 code  Exclude this AMQnnnn error\t\t (Default - none)\n");
printf("-X3 code  Exclude this AMQnnnn error\t\t (Default - none)\n");
printf("-S  s|d   Summary or Detail. s = Summary\t (Default - d)\n");
printf("    d = detail\n");
printf(" \n");
} /* End disphelp                                                   */
/* Sort the errors found                                            */
void sorterrs(char *strings[], int num)
{
 char *temp;
 int i, j;
 for (i = 0; i < num -1; i++)
 for (j = i + 1; j < num; j++)
  if (strcmp(strings[i], strings[j]) > 0)
  {
   temp = strings[i];
   strings[i] = strings[j];
   strings[j] = temp;
  }
}
/* End LOGANAL */

